# DataMin

## Purpose

DataMin is a program which takes the output of a symbolic execution of a Java program to generate a corresponding minimiser. More information can be found in the companion paper.

## How to use

Examples are provided in the `Examples\` directory.
In the terminal, go to the `datamin\` folder, then type one of the following:

    python DataMin.py Examples/LoyaltyApp/
    python DataMin.py Examples/CreditApp/

## Requirements

DataMin depends on three main dependencies:

- Python 2.7, programming language: [Python website](https://www.python.org)
- javalang, Python package: `pip install javalang --user` [Package javalang website](https://pypi.python.org/pypi/javalang)
- Z3, theorem prover: [Z3 website](https://github.com/Z3Prover/z3)

Though not strictly needed to be executed, DataMin also relies on the output of the symbolic execution engine of the KeY Project: [Key Project SEE website](http://www.key-project.org/~key/eclipse/SED/index.html#SEE).

This has been tested under Mac OS X 10.11.

## Limitations

DataMin is a proof of concept.
As such, it has the following limitations:

- expressions over integers only;
- distributed minimiser limited to two. 

## Author

Thibaud Antignac, Chalmers University of Technology, thibaud.antignac@chalmers.se